﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MiniStm32JoeC_CoreLibrary.Components {
    public partial class SubUC_DInput : UserControl, iSubUcItems {
        MiniStm32BoardJoeC _board;
        PinInfo _pininfo;
        public SubUC_DInput(MiniStm32BoardJoeC referenceBoard, string[] para) {
            InitializeComponent();
            _board = referenceBoard;
            //0=cmd,1=loc,2=label,3=pin,4=secondPara
            txt_Label.Text = para[2];
            _pininfo = new PinInfo(para[3]);
            label_pin.Text = para[3];
            _pininfo.EnumPinMode = PinMode.IF_In_Floating;
        }

        public void WriteConfigToBoard() { 
            try {
                _board.SetPinLine(new string[] { _pininfo.PinCfg }, PinSetState.PinState_In_Float);
                Read(true);
            } catch (Exception) {
                label_Value.BackColor = Color.Fuchsia;
            }
        }
        public string GetSetting() {
            //0=cmd,1=loc,2=label,3=pin,4=secondPara
            return $"DIN#{Location.X}:{Location.Y}#{txt_Label.Text}#{_pininfo.PinName}#";
        }
        public void SetSetting(string[] para) {
            //do nothing
        }
        public void Read(bool forceRead) {
            if (!chk_Active.Checked || forceRead) {
                return;
            }
            try {
                bool state = _board.GetPinInputState(_pininfo.PinCfg);
                label_Value.Text = (state) ? "High" : "Low";
                label_Value.BackColor = (state) ? Color.Salmon : Color.PaleGreen;
            } catch (Exception) {
                label_Value.BackColor = Color.Fuchsia;
            }
        }

        public void EditMode(bool isEditable) {
            txt_Label.Enabled = isEditable;
        }
    }
}
